VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AirBrush"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain
Dim undoch As Changes
Dim usewalltile As Boolean
Dim iswalltile(1023, 1023) As Boolean

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, x As Single, y As Single)
   On Error GoTo MouseDown_Error

    parent.undoredo.ResetRedo
    Set undoch = New Changes
        
    Call MouseMove(Button, x, y)

   On Error GoTo 0
   Exit Sub

MouseDown_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseDown of Class Module AirBrush"
End Sub

Sub MouseMove(Button As Integer, x As Single, y As Single)
   On Error GoTo MouseMove_Error

setAnotherRandom:
    If SharedVar.MouseDown = False Then
        Exit Sub
    End If

    Dim curtilex As Integer
    Dim curtiley As Integer
    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))
    If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
        Exit Sub
    End If

    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer

    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
        tmpTileSizeX = parent.multTileLeftx
        tmpTileSizeY = parent.multTileLefty
        usewalltile = parent.useWallTileLeft
        parent.walltiles.curwall = parent.curWallTileLeft
    Else
        tmptile = parent.tilesetright
        tmpTileSizeX = parent.multTileRightx
        tmpTileSizeY = parent.multTileRighty
        usewalltile = parent.useWallTileRight
        parent.walltiles.curwall = parent.curWallTileRight
    End If
    
    
    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If
    
    'use linew to define the region of the airbrush
    Dim i As Integer
    Dim j As Integer
    '1 - 3 - 5 -->
    '5 - 15 - 25
    Randomize
        
    For i = 0 To parent.tline.linew * 5
        Dim rndx As Integer
        Dim rndy As Integer
        rndx = Rnd() * Int(parent.tline.linew * 5) + curtilex - Int((parent.tline.linew * 5) / 2)
        rndy = Rnd() * Int(parent.tline.linew * 5) + curtiley - Int((parent.tline.linew * 5) / 2)
        If rndx < 0 Then rndx = 0
        If rndx > 1023 Then rndx = 1023
        If rndy < 0 Then rndy = 0
        If rndy > 1023 Then rndy = 1023
        
         If parent.pastetype <> p_under Or _
            parent.pastetype = p_under And parent.getTile(rndx, rndy) = 0 Then
            If isTileSpecial(parent, rndx, rndy) Then
                Call SearchAndDestroyObject(parent, curtilex, curtiley, undoch)
            End If
            If rndx <= 1023 And rndx >= 0 And rndy <= 1023 And rndy >= 0 Then
                If usewalltile Then
                    Call parent.walltiles.setIsWallTile(rndx, rndy)
                    tmptile = parent.walltiles.DrawWallTile(rndx, rndy, True, undoch, False)
                    Call parent.walltiles.setIsWallTile(rndx, rndy, True)
                End If
                Call parent.setTile(rndx, rndy, tmptile, undoch)
                Call parent.UpdateLevelTile(rndx, rndy, False)
            End If
        End If
    Next
        
    If parent.magnifier.UsingPixels Then
        parent.UpdateLevel
    Else
        parent.UpdatePreview
    End If
    
    If SharedVar.MouseDown Then
        Sleep 25
        DoEvents
        GoTo setAnotherRandom
    End If
    
    parent.mapchanged = True

   On Error GoTo 0
   Exit Sub

MouseMove_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseMove of Class Module AirBrush"
End Sub

Sub MouseUp()
    'do nothing
   On Error GoTo MouseUp_Error

    Call parent.undoredo.AddToUndo(undoch)
    'when using tile 0 we need to redraw grid
    parent.UpdateLevel

   On Error GoTo 0
   Exit Sub

MouseUp_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseUp of Class Module AirBrush"
    
End Sub


